ALTER TABLE PESSOA ADD CDCLIENTE VARCHAR2(21) NULL
/

ALTER TABLE PESSOA ADD DSEMAILPESSOA VARCHAR2(40) NULL
/

ALTER TABLE PESSOA ADD IDSOLICITA VARCHAR2(1) DEFAULT 'N' NULL
	CONSTRAINT CKC_IDSOLICITA_PESSOA CHECK (IDSOLICITA IN ('S','N'))
/

ALTER TABLE PESSOA ADD IDAPROVA VARCHAR2(1) DEFAULT 'N' NULL
	CONSTRAINT CKC_IDAPROVA_PESSOA CHECK (IDAPROVA IN ('S','N'))
/

ALTER TABLE PESSOA ADD DSSENHAPESSOA VARCHAR2(200) NULL
/

ALTER TABLE PESSOA ADD IDAPPORIGEM VARCHAR2(30) NULL
	CONSTRAINT CKC_IDAPPORIGEM_PESSOA CHECK (IDAPPORIGEM IN ('MYORDER'))
/

ALTER TABLE PESSOA
	ADD CONSTRAINT FKMYO00001CLIENTE FOREIGN KEY (CDCLIENTE)
		REFERENCES CLIENTE (CDCLIENTE)
/

CREATE INDEX FKMYO00001CLIENTE ON PESSOA (CDCLIENTE) 
/

CREATE TABLE PEDIDOSERV(	
NRPEDIDOSERV		NUMBER			NOT NULL,
CDFILIAL				VARCHAR2(4)		NOT NULL,
CDCLIENTE			VARCHAR2(21)	NOT NULL,
DTPEDIDO				DATE				NOT NULL,
DTENTREGA			DATE	    		NOT NULL,
IDSTATUS				VARCHAR2(30)	NOT NULL
	CONSTRAINT CKC_IDSTATUS_PEDIDOSERV CHECK (IDSTATUS IN ('PENDENTE', 'APROVADO', 'EMPRODUCAO', 'FINALIZADO', 'ENTREGUE', 'CANCELADO')),
NRPESSOA				VARCHAR2(10)	NOT NULL,
NRLANCTONF			VARCHAR2(10)	NULL,
DSLOCALENTREGA 	VARCHAR2(200) 	NULL,
NRORG 				NUMBER 			DEFAULT 1 	NOT NULL, 
IDATIVO 				VARCHAR2(1) 	DEFAULT 'S' NOT NULL 
	CONSTRAINT CKC_IDATIVO_PEDIDOSERV CHECK (IDATIVO IN ('S','N')),
DTINCLUSAO 			DATE 				DEFAULT 		NULL, 
DTULTATU 			DATE 				DEFAULT 		NULL, 
NRORGINCLUSAO 		NUMBER 			DEFAULT 1 	NULL, 
CDOPERINCLUSAO 	VARCHAR2(12) 	DEFAULT '1' NULL, 
NRORGULTATU 		NUMBER 			DEFAULT 1 	NULL, 
CDOPERULTATU 		VARCHAR2(12) 	DEFAULT '1' NULL,
CONSTRAINT PK_PEDIDOSERV PRIMARY KEY (NRPEDIDOSERV)
)
/

ALTER TABLE PEDIDOSERV
	ADD CONSTRAINT FKMYO00002FILIAL FOREIGN KEY (CDFILIAL)
		REFERENCES FILIAL (CDFILIAL)
/

CREATE INDEX FKMYO00002FILIAL ON PEDIDOSERV (CDFILIAL)
/

ALTER TABLE PEDIDOSERV
	ADD CONSTRAINT FKMYO00003CLIENTE FOREIGN KEY (CDCLIENTE)
		REFERENCES CLIENTE (CDCLIENTE)
/

CREATE INDEX FKMYO00003CLIENTE ON PEDIDOSERV (CDCLIENTE)
/

ALTER TABLE PEDIDOSERV
	ADD CONSTRAINT FKMYO00004PESSOA FOREIGN KEY (NRPESSOA)
		REFERENCES PESSOA (NRPESSOA)
/

CREATE INDEX FKMYO00004PESSOA ON PEDIDOSERV (NRPESSOA)
/

ALTER TABLE PEDIDOSERV
	ADD CONSTRAINT FKMYO00005NOTAFISCAL FOREIGN KEY(CDFILIAL, NRLANCTONF)
		REFERENCES NOTAFISCAL (CDFILIAL, NRLANCTONF)
/

CREATE INDEX FKMYO00005NOTAFISCAL ON PEDIDOSERV (CDFILIAL, NRLANCTONF)
/

CREATE TABLE ITEMPEDIDOSERV(
NRITEMPEDIDOSERV     NUMBER		   NOT NULL,
NRPEDIDOSERV 			NUMBER			NOT NULL,
CDFILIAL					VARCHAR2(4)		NOT NULL,
CDSERVFILI				VARCHAR2(5)		NOT NULL,
QTDEPEDIDO				NUMBER			NOT NULL,
DSOBSERVACAO			VARCHAR2(200)	NULL,
NRORG 					NUMBER 			DEFAULT 1 	NOT NULL, 
IDATIVO 					VARCHAR2(1) 	DEFAULT 'S' NOT NULL 
	CONSTRAINT CKC_IDATIVO_ITEMPEDIDOSERV CHECK (IDATIVO IN ('S','N')),
DTINCLUSAO 				DATE 				DEFAULT 		NULL, 
DTULTATU 				DATE 				DEFAULT 		NULL, 
NRORGINCLUSAO 			NUMBER 			DEFAULT 1 	NULL, 
CDOPERINCLUSAO 		VARCHAR2(12) 	DEFAULT '1' NULL, 
NRORGULTATU 			NUMBER 			DEFAULT 1 	NULL, 
CDOPERULTATU 			VARCHAR2(12) 	DEFAULT '1' NULL,
CONSTRAINT PK_ITEMPEDIDOSERV PRIMARY KEY(NRITEMPEDIDOSERV)     
)
/

ALTER TABLE ITEMPEDIDOSERV
	ADD CONSTRAINT FKMYO00006PEDIDOSERV FOREIGN KEY(NRPEDIDOSERV)
		REFERENCES PEDIDOSERV (NRPEDIDOSERV)
/

CREATE INDEX FKMYO00006PEDIDOSERV ON ITEMPEDIDOSERV (NRPEDIDOSERV)
/

ALTER TABLE ITEMPEDIDOSERV
	ADD CONSTRAINT FKMYO00007FILIAL	FOREIGN KEY(CDFILIAL)
		REFERENCES FILIAL (CDFILIAL)
/

CREATE INDEX FKMYO00007FILIAL ON ITEMPEDIDOSERV (CDFILIAL)
/

ALTER TABLE ITEMPEDIDOSERV
	ADD CONSTRAINT FKMYO00008SERVICO FOREIGN KEY(CDFILIAL, CDSERVFILI)
		REFERENCES SERVICO (CDFILIAL, CDSERVFILI)
/

CREATE INDEX FKMYO00008SERVICO ON ITEMPEDIDOSERV (CDFILIAL, CDSERVFILI)
/

ALTER TABLE SERVICO ADD IDDISPOPEDIDOSERV VARCHAR2(1) DEFAULT 'N' NOT NULL
	CONSTRAINT CKC_IDDISPOPEDIDOSERV_SERVICO CHECK (IDDISPOPEDIDOSERV IN ('S','N'))
/

ALTER TABLE SERVICO ADD NRLIMSEGPEDIDO NUMBER NULL
/

ALTER TABLE SERVICO ADD DSOBSERVACAOSERVICO VARCHAR2(100) NULL
/

ALTER TABLE SERVICO ADD FGFOTOSERVICO VARCHAR2(2000) NULL
/